up to 5.2.20
[packages/VirtualBox.git] / mount.vdi
CommitLineData
299eae76
ER
1#!/bin/sh
2#==============================================================================
3# mount.vdi
4# Copyright (C) Elan Ruusamäe <glen@pld-linux.org>, 2008
5#
6# This program is free software; you can redistribute it and/or
7# modify it under the terms of the GNU General Public License as
8# published by the Free Software Foundation; either version 2 of
9# the License, or (at your option) any later version.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# General Public License for more details.
15#
16# You should have received a copy of the GNU General Public
17# License along with this program; if not, write to:
18# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
19# Boston, MA 02110-1301 USA
20#
21# -- For details, see the file named "LICENSE.GPLv2"
22#==============================================================================
23
24# Sanitize environment
25export PATH=/bin:/sbin:/usr/bin:/usr/sbin
26
27# Commands
28LOSETUP=/sbin/losetup
29MOUNT=/bin/mount
735ce263 30PARTED=/usr/sbin/parted
24855e50 31SED=/bin/sed
299eae76
ER
32
33PROGRAM=${0##*/}
7e899501 34MOUNTARGS=
299eae76
ER
35OPTIONS=
36FSTYPE=
37
24855e50 38USAGE="<VDI image> <mountpoint> [-o options,...]
299eae76
ER
39
40Options:
41 partition=<number> Specify partition to mount
42 fstype=<fstype> Specify FS type instead of autodetecting
43"
44
45# This is braindead, two first args are dev and mountpoint if invoked from
46# mount(1), but could be option if invoked from mount.vdi(1)
47if [ -n "$1" ] && [[ "$1" != -* ]]; then
48 DEVICE=$1
49 shift
50fi
51if [ -n "$1" ] && [[ "$1" != -* ]]; then
52 MOUNTPOINT=$1
53 shift
54fi
55
56while :; do
57 case "$1" in
58 -h | "-?" )
59 echo >&2 "Usage: $PROGRAM $USAGE"
60 exit 0 ;;
7e899501 61 -o)
299eae76
ER
62 OPTIONS="$2";
63 shift ;;
7e899501
ER
64 -n)
65 MOUNTARGS="$MOUNTARGS $1"
66 ;;
299eae76
ER
67 -?* )
68 echo >&2 "$PROGRAM: unrecognized option: $1"
69 exit 1 ;;
70 *)
71 break ;;
72 esac
73 shift
74done
75
76if [ -z "$DEVICE" ]; then
77 echo >&2 "$PROGRAM: device to mount not specified"
78 exit 1
79fi
80
81if [ -z "$MOUNTPOINT" ]; then
82 echo >&2 "$PROGRAM: mount point not specified"
83 exit 1
84fi
85
86if [ ! -f "$DEVICE" ]; then
87 echo >&2 "$PROGRAM: $DEVICE is not a file"
88 exit 1
89fi
90
91if [ ! -d "$MOUNTPOINT" ]; then
92 echo >&2 "$PROGRAM: $MOUNTPOINT is not a directory"
93 exit 1
94fi
95
96# check magic
97magic=$(head -n 1 "$DEVICE")
71d8ada7
ER
98case "$magic" in
99"<<< innotek VirtualBox Disk Image >>>")
100 ;;
101"<<< Sun VirtualBox Disk Image >>>")
102 ;;
f7b82720
ER
103"<<< Oracle VM VirtualBox Disk Image >>>")
104 ;;
71d8ada7 105*)
299eae76
ER
106 echo >&2 "$PROGRAM: $DEVICE: bad magic, not VDI image"
107 exit 1
71d8ada7 108esac
299eae76
ER
109
110MOUNTOPTIONS=
111PARTITION=
112OFFSET=
113OLDIFS=$IFS
114IFS=", "
115for opt in $OPTIONS; do
3b729c5c
ER
116 KEY=${opt%=*};
117 VAL=${opt#*=};
299eae76
ER
118 case "$KEY" in
119 part|partition)
120 PARTITION="$VAL"
121 ;;
122 fstype)
123 FSTYPE="$VAL"
124 ;;
125 *)
126 if [ -z "$MOUNTOPTIONS" ]; then
127 MOUNTOPTIONS="$opt"
128 else
129 MOUNTOPTIONS="$MOUNTOPTIONS,$opt"
130 fi
131 ;;
132 esac
133done
134IFS="$OLDIFS"
135
136if [ -z "$PARTITION" ]; then
137 echo >&2 "$PROGRAM: missing partition option"
138 exit 1
139fi
140
141# offset when disk starts
142dskoff=8704
143
144# find free loop device. XXX race possible
735ce263 145imgdev=$($LOSETUP -f) || exit 1
24855e50 146$LOSETUP $imgdev -o $dskoff "$DEVICE"
735ce263
ER
147dump=$($PARTED -s -m $imgdev unit B print)
148$LOSETUP -d $imgdev || exit 1
149
150partoff=$(echo "$dump" | $SED -ne "s/^$PARTITION:"'\([0-9]*\)B:.*/\1/p')
151OFFSET=$((dskoff + partoff))
299eae76 152
735ce263 153if [ -z "$partoff" -o -z "$OFFSET" ]; then
299eae76
ER
154 echo >&2 "$PROGRAM: couldn't figure out offset, perhaps out of range?"
155 exit 1
156fi
157
158if [ -z "$MOUNTOPTIONS" ]; then
e1ca0050 159 MOUNTOPTIONS="loop,offset=$OFFSET"
299eae76 160else
e1ca0050 161 MOUNTOPTIONS="$MOUNTOPTIONS,loop,offset=$OFFSET"
299eae76
ER
162fi
163
164# $MOUNTPOINT might not exist as mount can try to read it from /etc/fstab
24855e50 165$MOUNT $MOUNTARGS ${FSTYPE:+-t "$FSTYPE"} ${MOUNTOPTIONS:+-o "$MOUNTOPTIONS"} "$DEVICE" "$MOUNTPOINT"
299eae76 166if [ $? -ne 0 ]; then
3b729c5c 167 echo >&2 "$PROGRAM: error mounting $DEVICE"
299eae76 168fi
This page took 0.102799 seconds and 4 git commands to generate.